{% extends "customers/base.html" %}
{% load i18n %}
{% load staticfiles %}
{% load active_tag %}
{% load md2 %}

{% block title %}Matrix - Reportes{% endblock %}

{% block extra_head %}
<link href="{% static 'theme/plugins/c3/c3.min.css' %}" rel="stylesheet" type="text/css">
{% endblock extra_head %}

{% block breadcrumbs %}
  {{ block.super }}
  <li><a href="{% url 'reports' %}">Reportes</a></li>
{% endblock breadcrumbs %}

{% block content %}
<section class="page-container">
  {% block heading %}
  <div class="page-header clearfix">
    <div class="pull-left">
      <h1 class="mt-0 mb-5">Contratos</h1>
      <h2 class="widget-title text-muted mb-10">Ver cambio de estados de servicios</h2>
    </div>
  </div>
  {% endblock heading %}

  <div class="page-content container-fluid">
    {% block navigation_tabs %}
    {% endblock navigation_tabs %}

    {% block main %}
    <div id="service-status-app">
    <div class="row">
      <h3>Variación en estado de servicios</h3>

      <div class="col-md-5">
	<h5 class="text-muted">Filtros:</h5>
	<p>
	<label>Desde:</label>
	<input type="date" v-model="initiald">
	</p>
	
	<p>
	  <label>Hasta:</label>
	  <input type="date" v-model="finald">
	</p>

	<p>
	<label>Estado:</label>
	<v-select v-model="selectedStatus" :options="statusOptions"></v-select>
	</p>

	<p>
	<label>Vendedor:</label>
	<v-select v-model="selectedSeller" :options="sellerOptions"></v-select>
	</p>

	<p>
	<label>Nodo:</label>
	<v-select v-model="selectedNode" :options="nodeOptions"></v-select>
	</p>

      </div>

    <div class="col-md-4">
      {% verbatim %}
      <h4>Datos de servicios</h4>
    <h5 class="text-muted">>{{ message }}</h5>
    <table class="table table-bordered">

	<tr v-for="(item, key, index) in snapshots">
	  <td>{{ key }}</td>
	  <td>{{ item }}</td>
	</tr>
    </table>
      {% endverbatim %}
    </div>
    </div>
    </div> <!-- service-status-app -->

    <div class="row">
    <h3>Pagos</h3>

    <div id="payments-app">
      <div class="col-md-5">
	<h5 class="text-muted">Filtros:</h5>
	<p>
	<label>Desde:</label>
	<input type="date" v-model="initiald">
	</p>
	
	<p>
	  <label>Hasta:</label>
	  <input type="date" v-model="finald">
	</p>
      </div>

    <div class="col-md-4">
      {% verbatim %}
      <h4>Datos de pagos</h4>
    <h5 class="text-muted">>{{ message }}</h5>
    <table class="table table-bordered">
      <thead>
	<tr>
	  <th>Tipo</th>
	  <th>Cantidad</th>
	  <th>Monto total</th>
	</tr>
      </thead>
      <tbody>
	<tr v-for="(item, key, index) in snapshots">
	  <td>{{ key }}</td>
	  <td align="right">{{ item.count | thousand }}</td>
	  <td align="right">{{ item.amount | thousand | clp }}</td>
	</tr>
      </tbody>
    </table>
    <h5>Cantidad de pagos total: <strong>{{ total_count | thousand }}</strong></h5>
    <h5>Monto total global: <strong>{{ total_amount | thousand | clp }}</strong></h5>
      {% endverbatim %}
    </div>
    </div> <!-- payments-app -->

    </div>
    {% endblock %}
  </div>
</section>
{% endblock content %}

{% block le_javascript %}
<script src="{% static 'js/vue' %}"></script>
    <script src="{% static 'js/accounting' %}"></script>
    <script src="{% static 'js/vue-resource' %}"></script>
    <script src="{% static 'js/vue-select' %}"></script>
    <script src="{% static 'js/vue-numeric' %}"></script>
    <script src="{% static 'js/lodash.min.js' %}"></script>

<script>
    get = function(obj, key) {
	return key.split(".").reduce(function(o, x) {
	    return (typeof o == "undefined" || o === null) ? o : o[x];
	}, obj);
    }

  Vue.component('v-select', VueSelect.VueSelect);
  Vue.use(VueNumeric.default);

  // Register a global custom directive called v-focus
  Vue.directive('focus', {
  // When the bound element is inserted into the DOM...
  inserted: function (el) {
  // Focus the element
  el.focus()
    
  }
  
  })

  var service_status_app = new Vue({
      el: '#service-status-app',
      data: {
          message: null,
	  initiald: "{{ first_of_month }}",
	  finald: "{{ last_of_month }}",
	  snapshots: {},
	  nodeOptions: [{value: null, label: "Todos"},{% for node in nodes %}{value: {{ node.pk }}, label: "{{ node }}"},{% endfor %}],
	  selectedNode: {value: null, label: "Todos"},
	  sellerOptions: [{value: null, label: "Todos"},{% for seller in sellers %}{value: {{ seller.pk }}, label: "{{ seller }}"},{% endfor %}],
	  selectedSeller: {value: null, label: "Todos"},
	  statusOptions: [{value: null, label: "Todos"},{% for status in statuses %}{value: {{ status.code }}, label: "{{ status.name }}"},{% endfor %}],
	  selectedStatus: {value: null, label: "Todos"},
      },
      watch: {
	  initiald: function(newInitialD) {
	      if (newInitialD) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  finald: function(newFinalD) {
	      if (newFinalD) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  selectedStatus: function(newStatus) {
	      if (newStatus) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  selectedNode: function(newNode) {
	      if (newNode) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  selectedSeller: function(newSeller) {
	      if (newSeller) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  }
      },
      mounted: function () {
	  this.refreshData();
      },
      methods: {
	  refreshData: _.debounce(
	      function() {
		  this.$http.get('/customers/table-ajax/'+'?'+'initiald='+this.initiald+'&finald='+this.finald+'&status='+get(this.selectedStatus, 'value')+'&seller='+get(this.selectedSeller, 'value')+'&node='+get(this.selectedNode, 'value')).then(response => {
		      var unordered = response.body.snapshot_data;
		      var ordered = {};
		      Object.keys(unordered).sort().forEach(function(key) {
			  ordered[key] = unordered[key];
		      });
		      this.snapshots = ordered;
		      this.message = null;
		  });
	      },
	      300
	  )
      }
  })

  var payments_app = new Vue({
      el: '#payments-app',
      data: {
          message: null,
	  initiald: "{{ first_of_month }}",
	  finald: "{{ last_of_month }}",
	  snapshots: {},
	  total_count: null,
	  total_amount: null,
      },
      filters: {
	  clp: function(value) {
	      return '$'+value;
	  },
	  thousand: function(value){
	      if (value) {
		  return value.toLocaleString('es-CL');
	      } else {
		  return 0;
	      }
	  }
      },
      watch: {
	  initiald: function(newInitialD) {
	      if (newInitialD) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  finald: function(newFinalD) {
	      if (newFinalD) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
      },
      mounted: function () {
	  this.refreshData();
      },
      methods: {
	  refreshData: _.debounce(
	      function() {
		  this.$http.get('/customers/payments-table-ajax/'+'?'+'initiald='+this.initiald+'&finald='+this.finald).then(response => {
		      var unordered = response.body.snapshot_data;
		      var ordered = {};
		      Object.keys(unordered).sort().forEach(function(key) {
			  ordered[key] = unordered[key];
		      });
		      this.snapshots = ordered;
		      this.total_count = response.body.total_count;
		      this.total_amount = response.body.total_amount;
		      this.message = null;
		  });
	      },
	      300
	  )
      }
  })

</script>

{% endblock le_javascript %}
